clc
clear

caseName="cone";
prjPath="/home/yuak/OpenFOAM/yuak-5.0/run";

radius2=1.5;
len=1;
radius1min=0;
radius1max=radius2;
delta=1e-3
MaxIter=25

function [P,Y,iter]=golden(f,a,b,MaxIter,delta)
 r1=(sqrt(5)-1)/2;
 r2=r1^2;
 h=b-a;
 ya=f(a);
 yb=f(b);
 c=a+r2*h;
 d=a+r1*h;
 yc=f(c);
 yd=f(d);
 P=zeros(MaxIter+1,4);
 Y=zeros(MaxIter+1,4);
 P(1,:)=[a,b,c,d];
 Y(1,:)=[ya,yb,yc,yd];

 for iter=2:MaxIter //while (abs(yb-ya)>epsilon)|(h>delta)
  if(yc<yd)
   b=d;
   yb=yd;
   d=c;
   yd=yc;
   h=b-a;
   c=a+r2*h;
   yc=f(c);
  else
   a=c;
   ya=yc;
   c=d;
   yc=yd;
   h=b-a;
   d=a+r1*h;
   yd=f(d);
  end
  P(iter,:)=[a,b,c,d,b];
  Y(iter,:)=[ya,yc,yd,yb];
  printf("iter=%d abs(b-a)=%f yc=%f yd=%f\n",iter,h,yc,yd);
  if a==b|h<delta
    break;
  end
 end
endfunction

str1="#!/bin/sh\n"
str1=str1+"str=\""import Mesh,BuildRegularGeoms\\n";
//Cone(radius1,radius2,len,closed,edgelen,count)
str2="t=BuildRegularGeoms.Cone(%f,%f,%f,1,0.10,50)";
str3="\\nm=Mesh.Mesh(t)\\n";
str3=str3+"m.write(\\""./cone.ast\\"")\\n";
str3=str3+"del(m)\\n";
str3=str3+"del(t)\\n";
str3=str3+"exit()\\n\""\n";
str3=str3+"printf \""$str\"" | freecadcmd\n";
str3=str3+"mv cone.ast ./constant/triSurface/cone.stl\n";
//str4=". /opt/openfoam5/bin/tools/RunFunctions\n";
//str4=str4+"runApplication surfaceFeatureExtract\n";
//str4=str4+"runApplication blockMesh\n";
//
function radius2angle(radius1,radius2,len)
 angle=180*atan((radius2-radius1)/len)/%pi
endfunction

function value=ObjFunct(radius1)
 fd=mopen("opt.sh","w");
 mfprintf(fd,str1);
 str2=msprintf(str2,radius1,radius2,len);
 mfprintf(fd,str2);
 mfprintf(fd,str3);
 mclose(fd);
 host("chmod +x opt.sh");
 host("./opt.sh");
 unix_w("bash Allrun");
 ResFile=prjPath+"/"+caseName+"/postProcessing/forceCoeffs1/0/forceCoeffs.dat";
 M=csvRead(ResFile,ascii(9),[],[],[],[],[],9);
 [m,n]=size(M);
 value=M(m,3);
 unix_w("bash Allclean");
endfunction

tic();
chdir("/home/yuak/projects/OptOpenFoam/scilab");
unZipCmd="unzip -o ../cone.zip -d "+prjPath;
unix_w(unZipCmd);
chdir(prjPath+"/"+caseName);

[P,Y,iter]=golden(ObjFunct,radius1min,radius1max,MaxIter,delta)

disp(P,Y,iter)
//printf("\nFitting error=%f \n",fmin)
//xmin = pop_opt(ind)
//radius1opt=xmin;
//printf("\nOpt. radius 1=%g\n",radius1opt);
printf("execution time %f sec\n",toc());

